#include <stdio.h>
#include <bcm2835.h>
#include <mysql/mysql.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#define HOST "localhost"
#define USER "root"
#define PASS "mysqllt38c"
#define DB "lt38c"

#define PIN1 RPI_GPIO_P1_26 //07
#define PIN2 RPI_GPIO_P1_07 //04
#define PIN3 RPI_GPIO_P1_15 //22
#define PIN4 RPI_GPIO_P1_22 //25
#define PIN5 RPI_GPIO_P1_16 //23
#define PIN6 RPI_GPIO_P1_18 //24

MYSQL conexao;
MYSQL_RES *resp;
MYSQL_ROW linhas;

void pinSet(int pino, int state){
    switch (pino) {
        case 7:
            bcm2835_gpio_fsel(PIN1, BCM2835_GPIO_FSEL_OUTP);
            bcm2835_gpio_write(PIN1, state);
        break;
        case 3:
            bcm2835_gpio_fsel(PIN2, BCM2835_GPIO_FSEL_OUTP);
            bcm2835_gpio_write(PIN2, state);
        break;	    
        case 22:
            bcm2835_gpio_fsel(PIN3, BCM2835_GPIO_FSEL_OUTP);
            bcm2835_gpio_write(PIN3, state);
        break;
        case 25:
            bcm2835_gpio_fsel(PIN4, BCM2835_GPIO_FSEL_OUTP);
            bcm2835_gpio_write(PIN4, state);
        break;
        default:
            printf("Pino indisponível");
    }   
}

int pinRead(int pino){
    int valor = 2;
    switch (pino) {
        case 23:
            valor = bcm2835_gpio_lev(PIN5);
        break;
        case 24:
            valor = bcm2835_gpio_lev(PIN6);
        break;
        default:
            printf("Pino indisponível");
    }
    return valor;
}

void readServer(int *comando,int *pino){
    char query[128]="SELECT * FROM pinwr;";

    int conta, command, pin_number, res;

    if (mysql_real_connect(&conexao,HOST,USER,PASS,DB,0,NULL,0))
    {
        printf("Conectado com Sucesso!\n");
        if (mysql_query(&conexao,query)){
	    printf("entrou");
	    printf("Erro: %s\n",mysql_error(&conexao));
        }
	else
        {	
            resp = mysql_store_result(&conexao);
            if (resp)
            {
                while ((linhas=mysql_fetch_row(resp)) != NULL)
                {
                    *comando = atoi(linhas[1]);
                    *pino = atoi(linhas[2]);
                }
                res = mysql_query(&conexao,"UPDATE pinwr SET sync=0;");
            }
            mysql_free_result(resp);
        }
    }
    else
    {
        printf("Conexao Falhou\n");
        if (mysql_errno(&conexao)) printf("Erro %d : %s\n", mysql_errno(&conexao), mysql_error(&conexao));
    }
}

void writeServer(){
    int res, val1, val2;

    val1 = pinRead(23);
    val2 = pinRead(24);

    printf("Leitura dos pinos:23[%d] 24[%d]\n\n",val1,val2);

    char valor1 [7];
    char valor2 [7];

    if(val1 == 2 || val2 == 2){
        printf("comando indisponível");
    }
    else{
        if(val1 == 1){
            strcpy(valor1,"'HIGH'");
        }
        else{
            strcpy(valor1,"'LOW'");
        }
        
        if(val2 == 1){
            strcpy(valor2,"'HIGH'");
        }
        else{
            strcpy(valor2,"'LOW'");
        }
    }

    char *query1;
    query1 = malloc (128 * sizeof (char));
    strcpy(query1,"UPDATE pinrd SET pino = '23', modo = 'in', valor = ");
    strcat(query1,valor1);
    strcat(query1,", datah = 'NOW()' WHERE id = 1;");

    char *query2;
    query2 = malloc (128 * sizeof (char));
    strcpy(query2,"UPDATE pinrd SET pino = '24', modo = 'in', valor = ");
    strcat(query2,valor2);
    strcat(query2,", datah = 'NOW()' WHERE id = 2;");

    if (mysql_real_connect(&conexao,HOST,USER,PASS,DB,0,NULL,0))
    {
        printf("conectado com sucesso!\n");
        res = mysql_query(&conexao,query1);
        if (!res) {
            printf("Registros atualizados %ld\n", (long)mysql_affected_rows(&conexao));
        }
        else {
            printf("Erro na atualização %ld : %s\n", (long)mysql_errno(&conexao), mysql_error(&conexao));
        }

        res = mysql_query(&conexao,query2);
        if (!res) {
            printf("Registros atualizados %ld\n", (long)mysql_affected_rows(&conexao));
        }
        else {
            printf("Erro na atualização %ld : %s\n", (long)mysql_errno(&conexao), mysql_error(&conexao));
        }
    }
    else
    {
        printf("Falha de conexao\n");
        printf("Erro %d : %s\n", mysql_errno(&conexao), mysql_error(&conexao));
    }
    free(query1);
    free(query2);
}

void main()
{
    while(1)
    {   
	int comando, pino;

    mysql_init(&conexao);
    bcm2835_init();

    readServer(&comando,&pino);
    printf("Execução de comandos:[%d] [%d]\n",pino,comando);
    pinSet(pino,comando);

    mysql_close(&conexao);
    mysql_init(&conexao);

    writeServer();
    
    bcm2835_close();
    mysql_close(&conexao);

    usleep(50000);
    }
}
